FLTK 1.3.8: Drawing functions

FLTK 1.3.8

Macros | Enumerations | Functions | Variables
Drawing functions

FLTK global graphics and GUI drawing functions. More...

## Macros
#define | fl_clip fl_push_clip
| Intersects the current clip region with a rectangle and pushes this new region onto the stack (deprecated). More...

## Enumerations
enum | { FL_SOLID = 0 , FL_DASH = 1 , FL_DOT = 2 , FL_DASHDOT = 3 , FL_DASHDOTDOT = 4 , FL_CAP_FLAT = 0x100 , FL_CAP_ROUND = 0x200 , FL_CAP_SQUARE = 0x300 , FL_JOIN_MITER = 0x1000 , FL_JOIN_ROUND = 0x2000 , FL_JOIN_BEVEL = 0x3000 }

## Functions
void | Fl_Quartz_Graphics_Driver::copy_offscreen (int x, int y, int w, int h, Fl_Offscreen pixmap, int srcx, int srcy)
| see fl_copy_offscreen() More...
FL_EXPORT int | fl_add_symbol (const char *name, void(*drawit)(Fl_Color), int scalable)
| Adds a symbol to the system. More...
void | fl_arc (double x, double y, double r, double start, double end)
| Adds a series of points to the current path on the arc of a circle. More...
void | fl_arc (int x, int y, int w, int h, double a1, double a2)
| Draw ellipse sections using integer coordinates. More...
void | fl_begin_complex_polygon ()
| Starts drawing a complex filled polygon. More...
void | fl_begin_line ()
| Starts drawing a list of lines.
void | fl_begin_loop ()
| Starts drawing a closed sequence of lines.
void | fl_begin_offscreen (Fl_Offscreen ctx)
| Send all subsequent drawing commands to this offscreen buffer. More...
void | fl_begin_points ()
| Starts drawing a list of points. More...
void | fl_begin_polygon ()
| Starts drawing a convex filled polygon.
FL_EXPORT char | fl_can_do_alpha_blending ()
| Checks whether platform supports true alpha blending for RGBA images. More...
FL_EXPORT void | fl_chord (int x, int y, int w, int h, double a1, double a2)
| fl_chord declaration is a place holder - the function does not yet exist
void | fl_circle (double x, double y, double r)
| fl_circle() is equivalent to fl_arc(x,y,r,0,360), but may be faster. More...
int | fl_clip_box (int x, int y, int w, int h, int &X, int &Y, int &W, int &H)
| Intersects the rectangle with the current clip region and returns the bounding box of the result. More...
Fl_Region | fl_clip_region ()
| Returns the current clipping region.
void | fl_clip_region (Fl_Region r)
| Replaces the top of the clipping stack with a clipping region of any shape. More...
void | fl_copy_offscreen (int x, int y, int w, int h, Fl_Offscreen pixmap, int srcx, int srcy)
| Copy a rectangular area of the given offscreen buffer into the current drawing destination. More...
Fl_Offscreen | fl_create_offscreen (int w, int h)
| Creation of an offscreen graphics buffer. More...
FL_EXPORT void | fl_cursor (Fl_Cursor)
| Sets the cursor for the current window to the specified shape and colors. More...
FL_EXPORT void | fl_cursor (Fl_Cursor, Fl_Color fg, Fl_Color bg=FL_WHITE)
void | fl_curve (double X0, double Y0, double X1, double Y1, double X2, double Y2, double X3, double Y3)
| Adds a series of points on a Bezier curve to the path. More...
void | fl_delete_offscreen (Fl_Offscreen ctx)
| Deletion of an offscreen graphics buffer. More...
void | fl_draw (const char *str, int n, int x, int y)
| Draws starting at the given `x`, `y` location a UTF-8 string of length `n` bytes.
FL_EXPORT void | fl_draw (const char *str, int x, int y)
| Draws a nul-terminated UTF-8 string starting at the given `x`, `y` location. More...
FL_EXPORT void | fl_draw (const char *str, int x, int y, int w, int h, Fl_Align align, Fl_Image *img=0, int draw_symbols=1)
| Fancy string drawing function which is used to draw all the labels. More...
FL_EXPORT void | fl_draw (const char *str, int x, int y, int w, int h, Fl_Align align, void(*callthis)(const char *, int, int, int), Fl_Image *img=0, int draw_symbols=1)
| The same as fl_draw(const char*,int,int,int,int,Fl_Align,Fl_Image*,int) with the addition of the `callthis` parameter, which is a pointer to a text drawing function such as fl_draw(const char*, int, int, int) to do the real work.
void | fl_draw (int angle, const char *str, int n, int x, int y)
| Draws at the given `x`, `y` location a UTF-8 string of length `n` bytes rotating `angle` degrees counter-clockwise. More...
FL_EXPORT void | fl_draw (int angle, const char *str, int x, int y)
| Draws a nul-terminated UTF-8 string starting at the given `x`, `y` location and rotating `angle` degrees counter-clockwise. More...
FL_EXPORT void | fl_draw_box (Fl_Boxtype, int x, int y, int w, int h, Fl_Color)
| Draws a box using given type, position, size and color. More...
void | fl_draw_image (const uchar *buf, int X, int Y, int W, int H, int D=3, int L=0)
| Draws an 8-bit per color RGB or luminance image. More...
void | fl_draw_image (Fl_Draw_Image_Cb cb, void *data, int X, int Y, int W, int H, int D=3)
| Draws an image using a callback function to generate image data. More...
void | fl_draw_image_mono (const uchar *buf, int X, int Y, int W, int H, int D=1, int L=0)
| Draws a gray-scale (1 channel) image. More...
void | fl_draw_image_mono (Fl_Draw_Image_Cb cb, void *data, int X, int Y, int W, int H, int D=1)
| Draws a gray-scale image using a callback function to generate image data. More...
FL_EXPORT int | fl_draw_pixmap (char *const *data, int x, int y, Fl_Color=FL_GRAY)
| Draw XPM image data, with the top-left corner at the given position. More...
FL_EXPORT int | fl_draw_pixmap (const char *const *cdata, int x, int y, Fl_Color=FL_GRAY)
| Draw XPM image data, with the top-left corner at the given position. More...
FL_EXPORT int | fl_draw_symbol (const char *label, int x, int y, int w, int h, Fl_Color)
| Draw the named symbol in the given rectangle using the given color. More...
void | fl_end_complex_polygon ()
| Ends complex filled polygon, and draws.
void | fl_end_line ()
| Ends list of lines, and draws.
void | fl_end_loop ()
| Ends closed sequence of lines, and draws.
void | fl_end_offscreen ()
| Quit sending drawing commands to the current offscreen buffer.
void | fl_end_points ()
| Ends list of points, and draws.
void | fl_end_polygon ()
| Ends convex filled polygon, and draws.
FL_EXPORT const char * | fl_expand_text (const char *from, char *buf, int maxbuf, double maxw, int &n, double &width, int wrap, int draw_symbols=0)
| Copy `from` to `buf`, replacing control characters with ^X. More...
FL_EXPORT void | fl_frame (const char *s, int x, int y, int w, int h)
| Draws a series of line segments around the given box. More...
FL_EXPORT void | fl_frame2 (const char *s, int x, int y, int w, int h)
| Draws a series of line segments around the given box. More...
void | fl_gap ()
| Call fl_gap() to separate loops of the path. More...
void | fl_line (int x, int y, int x1, int y1)
| Draws a line from (x,y) to (x1,y1)
void | fl_line (int x, int y, int x1, int y1, int x2, int y2)
| Draws a line from (x,y) to (x1,y1) and another from (x1,y1) to (x2,y2)
void | fl_line_style (int style, int width=0, char *dashes=0)
| Sets how to draw lines (the "pen"). More...
void | fl_loop (int x, int y, int x1, int y1, int x2, int y2)
| Outlines a 3-sided polygon with lines.
void | fl_loop (int x, int y, int x1, int y1, int x2, int y2, int x3, int y3)
| Outlines a 4-sided polygon with lines.
FL_EXPORT void | fl_measure (const char *str, int &x, int &y, int draw_symbols=1)
| Measure how wide and tall the string will be when printed by the fl_draw() function with `align` parameter. More...
FL_EXPORT int | fl_measure_pixmap (char *const *data, int &w, int &h)
| Get the dimensions of a pixmap. More...
FL_EXPORT int | fl_measure_pixmap (const char *const *cdata, int &w, int &h)
| Get the dimensions of a pixmap. More...
void | fl_mult_matrix (double a, double b, double c, double d, double x, double y)
| Concatenates another transformation onto the current one. More...
int | fl_not_clipped (int x, int y, int w, int h)
| Does the rectangle intersect the current clip region? More...
FL_EXPORT unsigned int | fl_old_shortcut (const char *s)
| Emulation of XForms named shortcuts. More...
FL_EXPORT void | fl_overlay_clear ()
| Erase a selection rectangle without drawing a new one.
FL_EXPORT void | fl_overlay_rect (int x, int y, int w, int h)
| Draws a selection rectangle, erasing a previous one by XOR'ing it first.
void | fl_pie (int x, int y, int w, int h, double a1, double a2)
| Draw filled ellipse sections using integer coordinates. More...
void | fl_point (int x, int y)
| Draws a single pixel at the given coordinates.
void | fl_polygon (int x, int y, int x1, int y1, int x2, int y2)
| Fills a 3-sided polygon. More...
void | fl_polygon (int x, int y, int x1, int y1, int x2, int y2, int x3, int y3)
| Fills a 4-sided polygon. More...
void | fl_pop_clip ()
| Restores the previous clip region. More...
void | fl_pop_matrix ()
| Restores the current transformation matrix from the stack.
void | fl_push_clip (int x, int y, int w, int h)
| Intersects the current clip region with a rectangle and pushes this new region onto the stack. More...
void | fl_push_matrix ()
| Saves the current transformation matrix on the stack. More...
void | fl_push_no_clip ()
| Pushes an empty clip region onto the stack so nothing will be clipped.
FL_EXPORT uchar * | fl_read_image (uchar *p, int X, int Y, int W, int H, int alpha=0)
| Reads an RGB(A) image from the current window or off-screen buffer. More...
void | fl_rect (int x, int y, int w, int h)
| Draws a 1-pixel border inside the given bounding box. More...
void | fl_rect (int x, int y, int w, int h, Fl_Color c)
| Draws with passed color a 1-pixel border inside the given bounding box.
void | fl_rectf (int x, int y, int w, int h)
| Colors with current color a rectangle that exactly fills the given bounding box.
void | fl_rectf (int x, int y, int w, int h, Fl_Color c)
| Colors with passed color a rectangle that exactly fills the given bounding box.
FL_EXPORT void | fl_rectf (int x, int y, int w, int h, uchar r, uchar g, uchar b)
| Colors a rectangle with "exactly" the passed `r,g,b` color. More...
FL_EXPORT void | fl_reset_spot (void)
void | fl_restore_clip ()
| Undoes any clobbering of clip done by your program.
void | fl_rotate (double d)
| Concatenates rotation transformation onto the current one. More...
void | fl_rtl_draw (const char *str, int n, int x, int y)
| Draws a UTF-8 string of length `n` bytes right to left starting at the given `x`, `y` location.
void | fl_scale (double x)
| Concatenates scaling transformation onto the current one. More...
void | fl_scale (double x, double y)
| Concatenates scaling transformation onto the current one. More...
FL_EXPORT void | fl_scroll (int X, int Y, int W, int H, int dx, int dy, void(*draw_area)(void *, int, int, int, int), void *data)
| Scroll a rectangle and draw the newly exposed portions. More...
FL_EXPORT void | fl_set_spot (int font, int size, int X, int Y, int W, int H, Fl_Window *win=0)
FL_EXPORT void | fl_set_status (int X, int Y, int W, int H)
FL_EXPORT const char * | fl_shortcut_label (unsigned int shortcut)
| Get a human-readable string from a shortcut value. More...
FL_EXPORT const char * | fl_shortcut_label (unsigned int shortcut, const char **eom)
| Get a human-readable string from a shortcut value. More...
double | fl_transform_dx (double x, double y)
| Transforms distance using current transformation matrix. More...
double | fl_transform_dy (double x, double y)
| Transforms distance using current transformation matrix. More...
double | fl_transform_x (double x, double y)
| Transforms coordinate using the current transformation matrix. More...
double | fl_transform_y (double x, double y)
| Transforms coordinate using the current transformation matrix. More...
void | fl_transformed_vertex (double xf, double yf)
| Adds coordinate pair to the vertex list without further transformations. More...
void | fl_translate (double x, double y)
| Concatenates translation transformation onto the current one. More...
void | fl_vertex (double x, double y)
| Adds a single vertex to the current path. More...
void | fl_xyline (int x, int y, int x1)
| Draws a horizontal line from (x,y) to (x1,y)
void | fl_xyline (int x, int y, int x1, int y2)
| Draws a horizontal line from (x,y) to (x1,y), then vertical from (x1,y) to (x1,y2)
void | fl_xyline (int x, int y, int x1, int y2, int x3)
| Draws a horizontal line from (x,y) to (x1,y), then a vertical from (x1,y) to (x1,y2) and then another horizontal from (x1,y2) to (x3,y2)
void | fl_yxline (int x, int y, int y1)
| Draws a vertical line from (x,y) to (x,y1)
void | fl_yxline (int x, int y, int y1, int x2)
| Draws a vertical line from (x,y) to (x,y1), then a horizontal from (x,y1) to (x2,y1)
void | fl_yxline (int x, int y, int y1, int x2, int y3)
| Draws a vertical line from (x,y) to (x,y1) then a horizontal from (x,y1) to (x2,y1), then another vertical from (x2,y1) to (x2,y3)

## Variables
const int | stack_max = 16

## Detailed Description

FLTK global graphics and GUI drawing functions.

These functions are declared in <FL/fl_draw.H>, and in <FL/x.H> for offscreen buffer-related ones.

## Macro Definition Documentation

## ◆ fl_clip

#define fl_clip fl_push_clip

Intersects the current clip region with a rectangle and pushes this new region onto the stack (deprecated).

Parameters

  [in] | x,y,w,h | position and size

Deprecated:
  fl_clip(int, int, int, int) is deprecated and will be removed from future releases. Please use fl_push_clip(int x, int y, int w, int h) instead.

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
FL_SOLID | line style: `___________`
FL_DASH | line style: `_ _ _ _ _ _`
FL_DOT | line style: `. . . . . .`
FL_DASHDOT | line style: `_ . _ . _ .`
FL_DASHDOTDOT | line style: `_ . . _ . .`
FL_CAP_FLAT | cap style: end is flat
FL_CAP_ROUND | cap style: end is round
FL_CAP_SQUARE | cap style: end wraps end point
FL_JOIN_MITER | join style: line join extends to a point
FL_JOIN_ROUND | join style: line join is rounded
FL_JOIN_BEVEL | join style: line join is tidied

## Function Documentation

## ◆ copy_offscreen()

void Fl_Quartz_Graphics_Driver::copy_offscreen | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Fl_Offscreen | pixmap,
|  | int | srcx,
|  | int | srcy
| ) |  |
| virtual

see fl_copy_offscreen()

Reimplemented from Fl_Graphics_Driver.

## ◆ fl_add_symbol()

FL_EXPORT int fl_add_symbol | ( | const char * | name,
|  | void(*)(Fl_Color) | drawit,
|  | int | scalable
| ) |  |

Adds a symbol to the system.

Parameters

  [in] | name | name of symbol (without the "@")
  [in] | drawit | function to draw symbol
  [in] | scalable | set to 1 if `drawit` uses scalable vector drawing

Returns
  1 on success, 0 on failure

## ◆ fl_arc() [1/2]

void fl_arc | ( | double | x,
|  | double | y,
|  | double | r,
|  | double | start,
|  | double | end
| ) |  |
| inline

Adds a series of points to the current path on the arc of a circle.

You can get elliptical paths by using scale and rotate before calling fl_arc().

Parameters

  [in] | x,y,r | center and radius of circular arc
  [in] | start,end | angles of start and end of arc measured in degrees counter-clockwise from 3 o'clock. If `end` is less than `start` then it draws the arc in a clockwise direction.

Examples:

// Draw an arc of points
fl_begin_points();
fl_arc(100.0, 100.0, 50.0, 0.0, 180.0);
fl_end_points();
// Draw arc with a line
fl_begin_line();
fl_arc(200.0, 100.0, 50.0, 0.0, 180.0);
fl_end_line();
// Draw filled arc
fl_begin_polygon();
fl_arc(300.0, 100.0, 50.0, 0.0, 180.0);
fl_end_polygon();
fl_begin_points
void fl_begin_points()
Starts drawing a list of points.
Definition: fl_draw.H:362
fl_arc
void fl_arc(int x, int y, int w, int h, double a1, double a2)
Draw ellipse sections using integer coordinates.
Definition: fl_draw.H:304
fl_begin_polygon
void fl_begin_polygon()
Starts drawing a convex filled polygon.
Definition: fl_draw.H:374
fl_end_line
void fl_end_line()
Ends list of lines, and draws.
Definition: fl_draw.H:432
fl_end_polygon
void fl_end_polygon()
Ends convex filled polygon, and draws.
Definition: fl_draw.H:440
fl_begin_line
void fl_begin_line()
Starts drawing a list of lines.
Definition: fl_draw.H:366
fl_end_points
void fl_end_points()
Ends list of points, and draws.
Definition: fl_draw.H:428

## ◆ fl_arc() [2/2]

void fl_arc | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | double | a1,
|  | double | a2
| ) |  |
| inline

Draw ellipse sections using integer coordinates.

These functions match the rather limited circle drawing code provided by X and WIN32. The advantage over using fl_arc with floating point coordinates is that they are faster because they often use the hardware, and they draw much nicer small circles, since the small sizes are often hard-coded bitmaps.

If a complete circle is drawn it will fit inside the passed bounding box. The two angles are measured in degrees counter-clockwise from 3 o'clock and are the starting and ending angle of the arc, `a2` must be greater or equal to `a1`.

fl_arc() draws a series of lines to approximate the arc. Notice that the integer version of fl_arc() has a different number of arguments than the double version fl_arc(double x, double y, double r, double start, double end)

Parameters

  [in] | x,y,w,h | bounding box of complete circle
  [in] | a1,a2 | start and end angles of arc measured in degrees counter-clockwise from 3 o'clock. `a2` must be greater than or equal to `a1`.

## ◆ fl_begin_complex_polygon()

void fl_begin_complex_polygon | ( |  | ) |
| inline

Starts drawing a complex filled polygon.

The polygon may be concave, may have holes in it, or may be several disconnected pieces. Call fl_gap() to separate loops of the path.

To outline the polygon, use fl_begin_loop() and replace each fl_gap() with fl_end_loop();fl_begin_loop() pairs.

Note
  For portability, you should only draw polygons that appear the same whether "even/odd" or "non-zero" winding rules are used to fill them. Holes should be drawn in the opposite direction to the outside loop.

## ◆ fl_begin_offscreen()

void fl_begin_offscreen | ( | Fl_Offscreen | ctx | ) |

Send all subsequent drawing commands to this offscreen buffer.

Parameters

  ctx | the offscreen buffer.

## ◆ fl_begin_points()

void fl_begin_points | ( |  | ) |
| inline

Starts drawing a list of points.

Points are added to the list with fl_vertex()

## ◆ fl_can_do_alpha_blending()

FL_EXPORT char fl_can_do_alpha_blending | ( |  | ) |

Checks whether platform supports true alpha blending for RGBA images.

Returns
  1 if true alpha blending supported by platform
  0 not supported so FLTK will use screen door transparency

## ◆ fl_circle()

void fl_circle | ( | double | x,
|  | double | y,
|  | double | r
| ) |  |
| inline

fl_circle() is equivalent to fl_arc(x,y,r,0,360), but may be faster.

It must be the only thing in the path: if you want a circle as part of a complex polygon you must use fl_arc()

Parameters

  [in] | x,y,r | center and radius of circle

## ◆ fl_clip_box()

int fl_clip_box | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | int & | X,
|  | int & | Y,
|  | int & | W,
|  | int & | H
| ) |  |
| inline

Intersects the rectangle with the current clip region and returns the bounding box of the result.

Returns non-zero if the resulting rectangle is different to the original. This can be used to limit the necessary drawing to a rectangle. `W` and `H` are set to zero if the rectangle is completely outside the region.

Parameters

  [in] | x,y,w,h | position and size of rectangle
  [out] | X,Y,W,H | position and size of resulting bounding box.

Returns
  Non-zero if the resulting rectangle is different to the original.

## ◆ fl_clip_region()

void fl_clip_region | ( | Fl_Region | r | ) |
| inline

Replaces the top of the clipping stack with a clipping region of any shape.

Fl_Region is an operating system specific type.

Parameters

  [in] | r | clipping region

## ◆ fl_copy_offscreen()

void fl_copy_offscreen | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Fl_Offscreen | pixmap,
|  | int | srcx,
|  | int | srcy
| ) |  |

Copy a rectangular area of the given offscreen buffer into the current drawing destination.

Parameters

  x,y | position where to draw the copied rectangle
  w,h | size of the copied rectangle
  pixmap | offscreen buffer containing the rectangle to copy
  srcx,srcy | origin in offscreen buffer of rectangle to copy

## ◆ fl_create_offscreen()

Fl_Offscreen fl_create_offscreen | ( | int | w,
|  | int | h
| ) |  |

Creation of an offscreen graphics buffer.

Parameters

  w,h | width and height in pixels of the buffer.

Returns
  the created graphics buffer.

## ◆ fl_cursor()

FL_EXPORT void fl_cursor | ( | Fl_Cursor | c | ) |

Sets the cursor for the current window to the specified shape and colors.

The cursors are defined in the <FL/Enumerations.H> header file.

## ◆ fl_curve()

void fl_curve | ( | double | X0,
|  | double | Y0,
|  | double | X1,
|  | double | Y1,
|  | double | X2,
|  | double | Y2,
|  | double | X3,
|  | double | Y3
| ) |  |
| inline

Adds a series of points on a Bezier curve to the path.

The curve ends (and two of the points) are at X0,Y0 and X3,Y3.

Parameters

  [in] | X0,Y0 | curve start point
  [in] | X1,Y1 | curve control point
  [in] | X2,Y2 | curve control point
  [in] | X3,Y3 | curve end point

## ◆ fl_delete_offscreen()

void fl_delete_offscreen | ( | Fl_Offscreen | ctx | ) |

Deletion of an offscreen graphics buffer.

Parameters

  ctx | the buffer to be deleted.

## ◆ fl_draw() [1/4]

FL_EXPORT void fl_draw | ( | const char * | str,
|  | int | x,
|  | int | y
| ) |  |

Draws a nul-terminated UTF-8 string starting at the given `x`, `y` location.

Text is aligned to the left and to the baseline of the font. To align to the bottom, subtract fl_descent() from `y`. To align to the top, subtract fl_descent() and add fl_height(). This version of fl_draw provides direct access to the text drawing function of the underlying OS. It does not apply any special handling to control characters.

## ◆ fl_draw() [2/4]

FL_EXPORT void fl_draw | ( | const char * | str,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Fl_Align | align,
|  | Fl_Image * | img,
|  | int | draw_symbols
| ) |  |

Fancy string drawing function which is used to draw all the labels.

The string is formatted and aligned inside the passed box. Handles '\t' and '\n', expands all other control characters to '^X', and aligns inside or against the edges of the box. See Fl_Widget::align() for values of `align`. The value FL_ALIGN_INSIDE is ignored, as this function always prints inside the box. If `img` is provided and is not `NULL`, the image is drawn above or below the text as specified by the `align` value. The `draw_symbols` argument specifies whether or not to look for symbol names starting with the '@' character'

## ◆ fl_draw() [3/4]

void fl_draw | ( | int | angle,
|  | const char * | str,
|  | int | n,
|  | int | x,
|  | int | y
| ) |  |
| inline

Draws at the given `x`, `y` location a UTF-8 string of length `n` bytes rotating `angle` degrees counter-clockwise.

Note
  When using X11 (Unix, Linux, Cygwin et al.) this needs Xft to work. Under plain X11 (w/o Xft) rotated text is not supported by FLTK. A warning will be issued to stderr at runtime (only once) if you use this method with an angle other than 0.

## ◆ fl_draw() [4/4]

FL_EXPORT void fl_draw | ( | int | angle,
|  | const char * | str,
|  | int | x,
|  | int | y
| ) |  |

Draws a nul-terminated UTF-8 string starting at the given `x`, `y` location and rotating `angle` degrees counter-clockwise.

This version of fl_draw provides direct access to the text drawing function of the underlying OS and is supported by Xft, Win32 and MacOS fltk subsets.

## ◆ fl_draw_box()

FL_EXPORT void fl_draw_box | ( | Fl_Boxtype | t,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Fl_Color | c
| ) |  |

Draws a box using given type, position, size and color.

Parameters

  [in] | t | box type
  [in] | x,y,w,h | position and size
  [in] | c | color

## ◆ fl_draw_image() [1/2]

void fl_draw_image | ( | const uchar * | buf,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | D = `3`,
|  | int | L = `0`
| ) |  |
| inline

Draws an 8-bit per color RGB or luminance image.

Parameters

  [in] | buf | points at the "r" data of the top-left pixel. Color data must be in `r,g,b` order. Luminance data is only one `gray` byte.
  [in] | X,Y | position where to put top-left corner of image
  [in] | W,H | size of the image
  [in] | D | delta to add to the pointer between pixels. It may be any value greater than or equal to 1, or it can be negative to flip the image horizontally
  [in] | L | delta to add to the pointer between lines (if 0 is passed it uses `W` * `D`), and may be larger than `W` * `D` to crop data, or negative to flip the image vertically

It is highly recommended that you put the following code before the first `show()` of any window in your program to get rid of the dithering if possible:

Fl::visual(FL_RGB);
Fl::visual
static int visual(int)
Selects a visual so that your graphics are drawn correctly.
Definition: Fl_visual.cxx:118

Gray scale (1-channel) images may be drawn. This is done if `abs(D)` is less than 3, or by calling fl_draw_image_mono(). Only one 8-bit sample is used for each pixel, and on screens with different numbers of bits for red, green, and blue only gray colors are used. Setting `D` greater than 1 will let you display one channel of a color image.

Note:
  The X version does not support all possible visuals. If FLTK cannot draw the image in the current visual it will abort. FLTK supports any visual of 8 bits or less, and all common TrueColor visuals up to 32 bits.

## ◆ fl_draw_image() [2/2]

void fl_draw_image | ( | Fl_Draw_Image_Cb | cb,
|  | void * | data,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | D = `3`
| ) |  |
| inline

Draws an image using a callback function to generate image data.

You can generate the image as it is being drawn, or do arbitrary decompression of stored data, provided it can be decompressed to individual scan lines easily.

Parameters

  [in] | cb | callback function to generate scan line data
  [in] | data | user data passed to callback function
  [in] | X,Y | screen position of top left pixel
  [in] | W,H | image width and height
  [in] | D | data size in bytes (must be greater than 0)

See also
  fl_draw_image(const uchar* buf, int X,int Y,int W,int H, int D, int L)

The callback function `cb` is called with the `void*` `data` user data pointer to allow access to a structure of information about the image, and the `x`, `y`, and `w` of the scan line desired from the image. 0,0 is the upper-left corner of the image, not `x`, `y`. A pointer to a buffer to put the data into is passed. You must copy `w` pixels from scanline `y`, starting at pixel `x`, to this buffer.

Due to cropping, less than the whole image may be requested. So `x` may be greater than zero, the first `y` may be greater than zero, and `w` may be less than `W`. The buffer is long enough to store the entire `W` * `D` pixels, this is for convenience with some decompression schemes where you must decompress the entire line at once: decompress it into the buffer, and then if `x` is not zero, copy the data over so the `x'th` pixel is at the start of the buffer.

You can assume the `y's` will be consecutive, except the first one may be greater than zero.

If `D` is 4 or more, you must fill in the unused bytes with zero.

## ◆ fl_draw_image_mono() [1/2]

void fl_draw_image_mono | ( | const uchar * | buf,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | D = `1`,
|  | int | L = `0`
| ) |  |
| inline

Draws a gray-scale (1 channel) image.

See also
  fl_draw_image(const uchar* buf, int X,int Y,int W,int H, int D, int L)

## ◆ fl_draw_image_mono() [2/2]

void fl_draw_image_mono | ( | Fl_Draw_Image_Cb | cb,
|  | void * | data,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | D = `1`
| ) |  |
| inline

Draws a gray-scale image using a callback function to generate image data.

See also
  fl_draw_image(Fl_Draw_Image_Cb cb, void* data, int X,int Y,int W,int H, int D)

## ◆ fl_draw_pixmap() [1/2]

FL_EXPORT int fl_draw_pixmap | ( | char *const * | data,
|  | int | x,
|  | int | y,
|  | Fl_Color | bg
| ) |  |

Draw XPM image data, with the top-left corner at the given position.

The image is dithered on 8-bit displays so you won't lose color space for programs displaying both images and pixmaps.

Parameters

  [in] | data | pointer to XPM image data
  [in] | x,y | position of top-left corner
  [in] | bg | background color

Returns
  0 if there was any error decoding the XPM data.

## ◆ fl_draw_pixmap() [2/2]

FL_EXPORT int fl_draw_pixmap | ( | const char *const * | cdata,
|  | int | x,
|  | int | y,
|  | Fl_Color | bg
| ) |  |

Draw XPM image data, with the top-left corner at the given position.

See also
  fl_draw_pixmap(char* const* data, int x, int y, Fl_Color bg)

## ◆ fl_draw_symbol()

FL_EXPORT int fl_draw_symbol | ( | const char * | label,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | Fl_Color | col
| ) |  |

Draw the named symbol in the given rectangle using the given color.

Parameters

  [in] | label | name of symbol
  [in] | x,y | position of symbol
  [in] | w,h | size of symbol
  [in] | col | color of symbox

Returns
  1 on success, 0 on failure

## ◆ fl_expand_text()

FL_EXPORT const char * fl_expand_text | ( | const char * | from,
|  | char * | buf,
|  | int | maxbuf,
|  | double | maxw,
|  | int & | n,
|  | double & | width,
|  | int | wrap,
|  | int | draw_symbols
| ) |  |

Copy `from` to `buf`, replacing control characters with ^X.

Stop at a newline or if `maxbuf` characters written to buffer. Also word-wrap if width exceeds maxw. Returns a pointer to the start of the next line of characters. Sets n to the number of characters put into the buffer. Sets width to the width of the string in the current font.

## ◆ fl_frame()

FL_EXPORT void fl_frame | ( | const char * | s,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

Draws a series of line segments around the given box.

The string `s` must contain groups of 4 letters which specify one of 24 standard grayscale values, where 'A' is black and 'X' is white. The order of each set of 4 characters is: top, left, bottom, right. The result of calling fl_frame() with a string that is not a multiple of 4 characters in length is undefined. The only difference between this function and fl_frame2() is the order of the line segments.

Parameters

  [in] | s | sets of 4 grayscale values in top, left, bottom, right order
  [in] | x,y,w,h | position and size

## ◆ fl_frame2()

FL_EXPORT void fl_frame2 | ( | const char * | s,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

Draws a series of line segments around the given box.

The string `s` must contain groups of 4 letters which specify one of 24 standard grayscale values, where 'A' is black and 'X' is white. The order of each set of 4 characters is: bottom, right, top, left. The result of calling fl_frame2() with a string that is not a multiple of 4 characters in length is undefined. The only difference between this function and fl_frame() is the order of the line segments.

Parameters

  [in] | s | sets of 4 grayscale values in bottom, right, top, left order
  [in] | x,y,w,h | position and size

## ◆ fl_gap()

void fl_gap | ( |  | ) |
| inline

Call fl_gap() to separate loops of the path.

It is unnecessary but harmless to call fl_gap() before the first vertex, after the last vertex, or several times in a row.

## ◆ fl_line_style()

void fl_line_style | ( | int | style,
|  | int | width = `0`,
|  | char * | dashes = `0`
| ) |  |
| inline

Sets how to draw lines (the "pen").

If you change this it is your responsibility to set it back to the default using `fl_line_style(0)`.

Parameters

  [in] | style | A bitmask which is a bitwise-OR of a line style, a cap style, and a join style. If you don't specify a dash type you will get a solid line. If you don't specify a cap or join type you will get a system-defined default of whatever value is fastest.
  [in] | width | The thickness of the lines in pixels. Zero results in the system defined default, which on both X and Windows is somewhat different and nicer than 1.
  [in] | dashes | A pointer to an array of dash lengths, measured in pixels. The first location is how long to draw a solid portion, the next is how long to draw the gap, then the solid, etc. It is terminated with a zero-length entry. A `NULL` pointer or a zero-length array results in a solid line. Odd array sizes are not supported and result in undefined behavior.

Note
  Because of how line styles are implemented on Win32 systems, you must set the line style after setting the drawing color. If you set the color after the line style you will lose the line style settings.
  The `dashes` array does not work under Windows 95, 98 or Me, since those operating systems do not support complex line styles.

## ◆ fl_measure()

FL_EXPORT void fl_measure | ( | const char * | str,
|  | int & | w,
|  | int & | h,
|  | int | draw_symbols
| ) |  |

Measure how wide and tall the string will be when printed by the fl_draw() function with `align` parameter.

If the incoming `w` is non-zero it will wrap to that width.

The current font is used to do the width/height calculations, so unless its value is known at the time fl_measure() is called, it is advised to first set the current font with fl_font(). With event-driven GUI programming you can never be sure which widget was exposed and redrawn last, nor which font it used. If you have not called fl_font() explicitly in your own code, the width and height may be set to unexpected values, even zero!

Note: In the general use case, it's a common error to forget to set `w` to 0 before calling fl_measure() when wrap behavior isn't needed.

Parameters

  [in] | str | nul-terminated string
  [out] | w,h | width and height of string in current font
  [in] | draw_symbols | non-zero to enable @symbol handling [default=1]

// Example: Common use case for fl_measure()
const char *s = "This is a test";
int wi=0, hi=0; // initialize to zero before calling fl_measure()
fl_font(FL_HELVETICA, 14); // set current font face/size to be used for measuring
fl_measure(s, wi, hi); // returns pixel width/height of string in current font
FL_HELVETICA
const Fl_Font FL_HELVETICA
Helvetica (or Arial) normal (0)
Definition: Enumerations.H:877
fl_font
void fl_font(Fl_Font face, Fl_Fontsize fsize)
Sets the current font, which is then used in various drawing routines.
Definition: fl_draw.H:509
fl_measure
FL_EXPORT void fl_measure(const char *str, int &x, int &y, int draw_symbols=1)
Measure how wide and tall the string will be when printed by the fl_draw() function with align parame...
Definition: fl_draw.cxx:380

## ◆ fl_measure_pixmap() [1/2]

FL_EXPORT int fl_measure_pixmap | ( | char *const * | data,
|  | int & | w,
|  | int & | h
| ) |  |

Get the dimensions of a pixmap.

An XPM image contains the dimensions in its data. This function returns the width and height.

Parameters

  [in] | data | pointer to XPM image data.
  [out] | w,h | width and height of image

Returns
  non-zero if the dimensions were parsed OK
  0 if there were any problems

## ◆ fl_measure_pixmap() [2/2]

FL_EXPORT int fl_measure_pixmap | ( | const char *const * | cdata,
|  | int & | w,
|  | int & | h
| ) |  |

Get the dimensions of a pixmap.

See also
  fl_measure_pixmap(char* const* data, int &w, int &h)

## ◆ fl_mult_matrix()

void fl_mult_matrix | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d,
|  | double | x,
|  | double | y
| ) |  |
| inline

Concatenates another transformation onto the current one.

Parameters

  [in] | a,b,c,d,x,y | transformation matrix elements such that `X' = aX + cY + x` and `Y' = bX +dY + y`

## ◆ fl_not_clipped()

int fl_not_clipped | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |
| inline

Does the rectangle intersect the current clip region?

Parameters

  [in] | x,y,w,h | position and size of rectangle

Returns
  non-zero if any of the rectangle intersects the current clip region. If this returns 0 you don't have to draw the object.

Note
  Under X this returns 2 if the rectangle is partially clipped, and 1 if it is entirely inside the clip region.

## ◆ fl_old_shortcut()

FL_EXPORT unsigned int fl_old_shortcut | ( | const char * | s | ) |

Emulation of XForms named shortcuts.

Converts ascii shortcut specifications (eg. "^c") into the FLTK integer equivalent (eg. FL_CTRL+'c')

These ascii characters are used to specify the various keyboard modifier keys:

     # - Alt
     + - Shift
     ^ - Control
     ! - Meta
     @ - Command (Ctrl on linux/win, Meta on OSX)

These special characters can be combined to form chords of modifier keys. (See 'Remarks' below)

After the optional modifier key prefixes listed above, one can either specify a single keyboard character to use as the shortcut, or a numeric sequence in hex, decimal or octal.

Examples:

     "c"      -- Uses 'c' as the shortcut
     "#^c"    -- Same as FL_ALT|FL_CTRL|'c'
     "#^!c"   -- Same as FL_ALT|FL_CTRL|FL_META|'c'
     "@c"     -- Same as FL_COMMAND|'c' (see FL_COMMAND for platform specific behavior)
     "0x63"   -- Same as "c" (hex 63=='c')
     "99"     -- Same as "c" (dec 99=='c')
     "0143"   -- Same as "c" (octal 0143=='c')
     "^0x63"  -- Same as (FL_CTRL|'c'), or (FL_CTRL|0x63)
     "^99"    -- Same as (FL_CTRL|'c'), or (FL_CTRL|99)
     "^0143"  -- Same as (FL_CTRL|'c'), or (FL_CTRL|0143)

Remarks
  Due to XForms legacy, there are some odd things to consider when using the modifier characters.
  (1) You can use the special modifier keys for chords only if the modifiers are provided in this order: #, +, ^, !, @. Other ordering can yield undefined results.
  So for instance, Ctrl-Alt-c must be specified as "#^c" (and not "^#c"), due to the above ordering rule.
  (2) If you want to make a shortcut that uses one of the special modifier characters (as the character being modified), then to avoid confusion, specify the numeric equivalent, e.g.

       If you want..                    Then use..
       -----------------------------    ------------------------------
       '#' as the shortcut..            "0x23"  (instead of just "#").
       '+' as the shortcut..            "0x2b"  (instead of just "+").
       '^' as the shortcut..            "0x5e"  (instead of just "^").
       Alt-+ as the shortcut..          "#0x2b" (instead of "#+").
       Alt-^ as the shortcut..          "#0x5e" (instead of "#^").
       ..etc..

  As a general rule that's easy to remember, unless the shortcut key to be modified is a single alpha-numeric character [A-Z,a-z,0-9), it's probably best to use the numeric equivalents.

Todo:
  Fix these silly legacy issues in a future release to support more predictable behavior for the modifier keys.

## ◆ fl_pie()

void fl_pie | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | double | a1,
|  | double | a2
| ) |  |
| inline

Draw filled ellipse sections using integer coordinates.

Like fl_arc(), but fl_pie() draws a filled-in pie slice. This slice may extend outside the line drawn by fl_arc(); to avoid this use w - 1 and h - 1.

Parameters

  [in] | x,y,w,h | bounding box of complete circle
  [in] | a1,a2 | start and end angles of arc measured in degrees counter-clockwise from 3 o'clock. `a2` must be greater than or equal to `a1`.

## ◆ fl_polygon() [1/2]

void fl_polygon | ( | int | x,
|  | int | y,
|  | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2
| ) |  |
| inline

Fills a 3-sided polygon.

The polygon must be convex.

## ◆ fl_polygon() [2/2]

void fl_polygon | ( | int | x,
|  | int | y,
|  | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | int | x3,
|  | int | y3
| ) |  |
| inline

Fills a 4-sided polygon.

The polygon must be convex.

## ◆ fl_pop_clip()

void fl_pop_clip | ( |  | ) |
| inline

Restores the previous clip region.

You must call fl_pop_clip() once for every time you call fl_push_clip(). Unpredictable results may occur if the clip stack is not empty when you return to FLTK.

## ◆ fl_push_clip()

void fl_push_clip | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |
| inline

Intersects the current clip region with a rectangle and pushes this new region onto the stack.

Parameters

  [in] | x,y,w,h | position and size

## ◆ fl_push_matrix()

void fl_push_matrix | ( |  | ) |
| inline

Saves the current transformation matrix on the stack.

The maximum depth of the stack is 32.

## ◆ fl_read_image()

FL_EXPORT uchar * fl_read_image | ( | uchar * | p,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | alpha = `0`
| ) |  |

Reads an RGB(A) image from the current window or off-screen buffer.

Parameters

  [in] | p | pixel buffer, or NULL to allocate one
  [in] | X,Y | position of top-left of image to read
  [in] | W,H | width and height of image to read
  [in] | alpha | alpha value for image (0 for none)

Returns
  pointer to pixel buffer, or NULL if allocation failed.

The `p` argument points to a buffer that can hold the image and must be at least `W*H*3` bytes when reading RGB images, or `W*H*4` bytes when reading RGBA images. If NULL, fl_read_image() will create an array of the proper size which can be freed using `delete[]`.

The `alpha` parameter controls whether an alpha channel is created and the value that is placed in the alpha channel. If 0, no alpha channel is generated.

## ◆ fl_rect()

void fl_rect | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |
| inline

Draws a 1-pixel border inside the given bounding box.

This function is meant for quick drawing of simple boxes. The behavior is undefined for line widths that are not 1.

## ◆ fl_rectf()

FL_EXPORT void fl_rectf | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | uchar | r,
|  | uchar | g,
|  | uchar | b
| ) |  |

Colors a rectangle with "exactly" the passed `r,g,b` color.

On screens with less than 24 bits of color this is done by drawing a solid-colored block using fl_draw_image() so that the correct color shade is produced.

## ◆ fl_reset_spot()

FL_EXPORT void fl_reset_spot | ( | void |  | ) |

Todo:
  provide user documentation for fl_reset_spot function

## ◆ fl_rotate()

void fl_rotate | ( | double | d | ) |
| inline

Concatenates rotation transformation onto the current one.

Parameters

  [in] | d | - rotation angle, counter-clockwise in degrees (not radians)

## ◆ fl_scale() [1/2]

void fl_scale | ( | double | x | ) |
| inline

Concatenates scaling transformation onto the current one.

Parameters

  [in] | x | scale factor in both x-direction and y-direction

## ◆ fl_scale() [2/2]

void fl_scale | ( | double | x,
|  | double | y
| ) |  |
| inline

Concatenates scaling transformation onto the current one.

Parameters

  [in] | x,y | scale factors in x-direction and y-direction

## ◆ fl_scroll()

FL_EXPORT void fl_scroll | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | dx,
|  | int | dy,
|  | void(*)(void *, int, int, int, int) | draw_area,
|  | void * | data
| ) |  |

Scroll a rectangle and draw the newly exposed portions.

Parameters

  [in] | X,Y | position of top-left of rectangle
  [in] | W,H | size of rectangle
  [in] | dx,dy | pixel offsets for shifting rectangle
  [in] | draw_area | callback function to draw rectangular areas
  [in] | data | pointer to user data for callback The contents of the rectangular area is first shifted by `dx` and `dy` pixels. The `draw_area` callback is then called for every newly exposed rectangular area.

## ◆ fl_set_spot()

FL_EXPORT void fl_set_spot | ( | int | font,
|  | int | size,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | Fl_Window * | win = `0`
| ) |  |

Todo:
  provide user documentation for fl_set_spot function

## ◆ fl_set_status()

FL_EXPORT void fl_set_status | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H
| ) |  |

Todo:
  provide user documentation for fl_set_status function

## ◆ fl_shortcut_label() [1/2]

FL_EXPORT const char * fl_shortcut_label | ( | unsigned int | shortcut | ) |

Get a human-readable string from a shortcut value.

Unparse a shortcut value as used by Fl_Button or Fl_Menu_Item into a human-readable string like "Alt+N". This only works if the shortcut is a character key or a numbered function key. If the shortcut is zero then an empty string is returned. The return value points at a static buffer that is overwritten with each call.

Since
  FLTK 1.3.4 modifier key names can be localized, but key names can not yet be localized. This may be added to a future FLTK version.

Modifier key names (human-readable shortcut names) can be defined with the following global const char * pointer variables:

- fl_local_ctrl => name of FL_CTRL
- fl_local_alt => name of FL_ALT
- fl_local_shift => name of FL_SHIFT
- fl_local_meta => name of FL_META

fl_local_ctrl = "Strg"; // German for "Ctrl"
fl_local_shift = "Umschalt"; // German for "Shift"
fl_local_shift
FL_EXPORT const char * fl_local_shift
string pointer used in shortcuts, you can change it to another language
Definition: Fl.cxx:98
fl_local_ctrl
FL_EXPORT const char * fl_local_ctrl
string pointer used in shortcuts, you can change it to another language
Definition: Fl.cxx:96

The shortcut name will be constructed by adding all modifier names in the order defined above plus the name of the key. A '+' character is added to each modifier name unless it has a trailing '\' or a trailing '+'.

Example:

Ctrl+Alt+Shift+Meta+F12

The default values for modifier key names are as given above for all platforms except Mac OS X. Mac OS X uses graphical characters that represent the typical OS X modifier names in menus, e.g. cloverleaf, saucepan, etc. You may, however, redefine Mac OS X modifier names as well.

Parameters

  [in] | shortcut | the integer value containing the ascii character or extended keystroke plus modifiers

Returns
  a pointer to a static buffer containing human readable text for the shortcut

## ◆ fl_shortcut_label() [2/2]

FL_EXPORT const char * fl_shortcut_label | ( | unsigned int | shortcut,
|  | const char ** | eom
| ) |  |

Get a human-readable string from a shortcut value.

Parameters

  [in] | shortcut | the integer value containing the ascii character or extended keystroke plus modifiers
  [in] | eom | if this pointer is set, it will receive a pointer to the end of the modifier text

Returns
  a pointer to a static buffer containing human readable text for the shortcut

See also
  fl_shortcut_label(unsigned int shortcut)

## ◆ fl_transform_dx()

double fl_transform_dx | ( | double | x,
|  | double | y
| ) |  |
| inline

Transforms distance using current transformation matrix.

Parameters

  [in] | x,y | coordinate

## ◆ fl_transform_dy()

double fl_transform_dy | ( | double | x,
|  | double | y
| ) |  |
| inline

Transforms distance using current transformation matrix.

Parameters

  [in] | x,y | coordinate

## ◆ fl_transform_x()

double fl_transform_x | ( | double | x,
|  | double | y
| ) |  |
| inline

Transforms coordinate using the current transformation matrix.

Parameters

  [in] | x,y | coordinate

## ◆ fl_transform_y()

double fl_transform_y | ( | double | x,
|  | double | y
| ) |  |
| inline

Transforms coordinate using the current transformation matrix.

Parameters

  [in] | x,y | coordinate

## ◆ fl_transformed_vertex()

void fl_transformed_vertex | ( | double | xf,
|  | double | yf
| ) |  |
| inline

Adds coordinate pair to the vertex list without further transformations.

Parameters

  [in] | xf,yf | transformed coordinate

## ◆ fl_translate()

void fl_translate | ( | double | x,
|  | double | y
| ) |  |
| inline

Concatenates translation transformation onto the current one.

Parameters

  [in] | x,y | translation factor in x-direction and y-direction

## ◆ fl_vertex()

void fl_vertex | ( | double | x,
|  | double | y
| ) |  |
| inline

Adds a single vertex to the current path.

Parameters

  [in] | x,y | coordinate

- Copyright © 1998-2021 by Bill Spitzak and others.